22771278ce1a13fbcd169bd9a7ef17a4c9569d93
[openwrt/openwrt.git] / target / linux / ipq806x / base-files / lib / upgrade / linksys.sh
1 #
2 # Copyright (C) 2014-2015 OpenWrt.org
3 #
4
5 linksys_get_target_firmware() {
6
7 local cur_boot_part mtd_ubi0
8
9 cur_boot_part=$(/usr/sbin/fw_printenv -n boot_part)
10 if [ -z "${cur_boot_part}" ] ; then
11 mtd_ubi0=$(cat /sys/devices/virtual/ubi/ubi0/mtd_num)
12 case $(egrep ^mtd${mtd_ubi0}: /proc/mtd | cut -d '"' -f 2) in
13 kernel1|rootfs1)
14 cur_boot_part=1
15 ;;
16 kernel2|rootfs2)
17 cur_boot_part=2
18 ;;
19 esac
20 >&2 printf "Current boot_part='%s' selected from ubi0/mtd_num='%s'" \
21 "${cur_boot_part}" "${mtd_ubi0}"
22 fi
23
24 case $cur_boot_part in
25 1)
26 fw_setenv -s - <<-EOF
27 boot_part 2
28 auto_recovery yes
29 EOF
30 printf "kernel2"
31 return
32 ;;
33 2)
34 fw_setenv -s - <<-EOF
35 boot_part 1
36 auto_recovery yes
37 EOF
38 printf "kernel1"
39 return
40 ;;
41 *)
42 return
43 ;;
44 esac
45 }
46
47 linksys_get_root_magic() {
48 (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
49 }
50
51 platform_do_upgrade_linksys() {
52 local magic_long="$(get_magic_long "$1")"
53
54 mkdir -p /var/lock
55 local part_label="$(linksys_get_target_firmware)"
56 touch /var/lock/fw_printenv.lock
57
58 if [ ! -n "$part_label" ]
59 then
60 echo "cannot find target partition"
61 exit 1
62 fi
63
64 local target_mtd=$(find_mtd_part $part_label)
65
66 [ "$magic_long" = "73797375" ] && {
67 CI_KERNPART="$part_label"
68 if [ "$part_label" = "kernel1" ]
69 then
70 CI_UBIPART="rootfs1"
71 else
72 CI_UBIPART="rootfs2"
73 fi
74
75
76 # remove "squashfs" vol (in case we are flashing over a stock image, which is also UBI)
77
78 local mtdnum="$( find_mtd_index "$CI_UBIPART" )"
79 if [ ! "$mtdnum" ]; then
80 echo "cannot find ubi mtd partition $CI_UBIPART"
81 return 1
82 fi
83
84 local ubidev="$( nand_find_ubi "$CI_UBIPART" )"
85 if [ ! "$ubidev" ]; then
86 ubiattach -m "$mtdnum"
87 sync
88 ubidev="$( nand_find_ubi "$CI_UBIPART" )"
89 fi
90
91 if [ "$ubidev" ]; then
92
93 local squash_ubivol="$( nand_find_volume $ubidev squashfs )"
94
95 # kill volume
96 [ "$squash_ubivol" ] && ubirmvol /dev/$ubidev -N squashfs || true
97 fi
98
99
100 # complete std upgrade
101 nand_upgrade_tar "$1"
102 }
103 [ "$magic_long" = "27051956" ] && {
104 # check firmwares' rootfs types
105 local oldroot="$(linksys_get_root_magic $target_mtd)"
106 local newroot="$(linksys_get_root_magic "$1")"
107
108 if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]
109 # we're upgrading from a firmware with UBI to one with UBI
110 then
111 # erase everything to be safe
112 mtd erase $part_label
113 get_image "$1" | mtd -n write - $part_label
114 else
115 get_image "$1" | mtd write - $part_label
116 fi
117 }
118 }